(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.module = f()}})(function(){var define,module,exports;return (function(){function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s}return e})()({1:[function(require,module,exports){
const DEBUG=true;

const syntax = require('./syntax');
const events = {
    update: function(ui) {
      console.log("general update");
      updateModelLabels(ui,this);
      calcCustomVariables(ui,this);
      updateSuppliers(ui,this);
      cleanEndogenousTerms(ui,this);
      update_syntax(ui,this); 

    },

    onChange_items_changed: function(ui) {
    console.log("items changed");
      updateModelLabels(ui,this);
      updateSuppliers(ui,this);
      cleanEndogenousTerms(ui,this);
      update_syntax(ui,this);
    },

    onChange_latentName: function(ui) {
     console.log("change latent name");
     updateSuppliers(ui,this);
     cleanEndogenousTerms(ui,this);
     update_syntax(ui,this);

    },

     onChange_endogenousTerms: function(ui) {
       console.log(" endogenousTerms changed"); 
//      cleanEndogenousTerms(ui,this);
      update_syntax(ui,this);

    },
    onChange_endogenousSupplier: function(ui) {
     console.log("endosupplier change");
//     calcCustomVariables(ui,this);
//     prepareEndogenousTerms(ui,this);
//      cleanEndogenousTerms(ui,this);
      
    },
    onUpdate_endogenousSupplier: function(ui) {
     console.log("endosupplier update");
//     calcCustomVariables(ui,this);

    },

    onChange_varcov: function(ui) {

      update_syntax(ui,this);
    },
 
    onChange_varcovSupplier: function(ui) {
        let values = this.itemsToValues(ui.varcovSupplier.value());
        this.checkPairsValue(ui.varcov, values);
      
    },
    onUpdate_varcovSupplier: function(ui) {
      console.log("varcovsup update");
      
    },
    
    onChange_constraints: function(ui) {
      console.log("constraints changed");
      update_syntax(ui,this);
      
      
    },

     onChange_multigroup: function(ui) {
       
       var val = ui.multigroup.value();
       if (typeof(val)==="string")
             if (val.replace(/ /g,'').length===0)
                ui.multigroup.setValue(null);

     },
      onChange_cluster: function(ui) {
       console.log("Multilevel cluster changed");
       var val = ui.cluster.value();
       if (typeof(val)==="string")
             if (val.replace(/ /g,'').length===0)
                ui.cluster.setValue(null);

     },

     onEvent_nothing: function(ui) {
      console.log("I did not do anything");
    }



};



var initializeAll = function(ui, context) {
    console.log("initialize all");
//    updateSuppliers(ui,context);
//    prepareEndogenousTerms(ui,context);

};




const calcCustomVariables=function(ui,context) {
  
  console.log("calcCustomVariables");
  var endogenousIndicators=context.cloneArray(ui.endogenous.value(),[]);
  var exogenousIndicators=context.cloneArray(ui.exogenous.value(),[]);
  var endogenous=getLabels(endogenousIndicators);
  var exogenous=getLabels(exogenousIndicators);
  var latent=endogenous.concat(exogenous);

  let customVariables = [];
    for(let i = 0; i < latent.length; i++) {
        customVariables.push( { name: latent[i], measureType: 'none', dataType: 'none', levels: [] } );
    }
  context.setCustomVariables(customVariables);

  
};

const updateSuppliers=function(ui, context) {
  
  console.log("updateSuppliers function");
  var endogenousIndicators=context.cloneArray(ui.endogenous.value(),[]);
  var exogenousIndicators=context.cloneArray(ui.exogenous.value(),[]);
  var endogenous=getLabels(endogenousIndicators);
  var exogenous=getLabels(exogenousIndicators);
  var latent=endogenous.concat(exogenous);

  let customVariables = [];
    for(let i = 0; i < latent.length; i++) {
        customVariables.push( { name: latent[i], measureType: 'none', dataType: 'none', levels: [] } );
    }
  
  context.setCustomVariables(customVariables);
  ui.endogenousSupplier.setValue(context.valuesToItems(latent, FormatDef.variable));

  var vars=[];  
   for (var i = 0; i < endogenousIndicators.length; i++) {
      if  (endogenousIndicators[i]!==undefined)
        if  (endogenousIndicators[i].vars!==undefined & endogenousIndicators[i].vars!==null) {
             for (var j = 0; j < endogenousIndicators[i].vars.length; j++) {
                vars.push(endogenousIndicators[i].vars[j]); 
             }
        }
     }
   for (var i = 0; i < exogenousIndicators.length; i++) {
      if  (exogenousIndicators[i]!==undefined)
        if  (exogenousIndicators[i].vars!==undefined & exogenousIndicators[i].vars!==null) {
             for (var j = 0; j < exogenousIndicators[i].vars.length; j++) {
                vars.push(exogenousIndicators[i].vars[j]); 
             }
        }
     }

  var allvars=unique(latent.concat(vars));
  ui.varcovSupplier.setValue(context.valuesToItems(allvars, FormatDef.variable));
  context.workspace.varcovSupplierList=allvars;

};

const updateModelLabels = function(ui,context) {
    var list1 = ui.endogenous.applyToItems(0, (item, index) => {
        let value = item.controls[0].value();
        if ( ! value || value.trim() === '')
            item.controls[0].setValue("Endogenous " + (index + 1) );
    });
    var list2 = ui.exogenous.applyToItems(0, (item, index) => {
        let value = item.controls[0].value();
        if ( ! value || value.trim() === '')
            item.controls[0].setValue("Exogenous " + (index + 1) );
    });
    
    

};

var prepareEndogenousTerms= function(ui,context) {

     // here we prepare a list of lists, one of each endogenous variable.
     // we also want to put a label to show which dependent variable the user is working on

     console.log("prepareEndogenousTerms");
     var endogenous = getLabels(context.cloneArray(ui.endogenous.value(),[]));
     var endogenousTerms = context.cloneArray(ui.endogenousTerms.value(),[]);
     
 
     // we make sure that there are enough arrays in the array list, each for each endogeneous
     var okList= [];
     for (var i = 0; i < endogenous.length; i++) {
         var aList = endogenousTerms[i] === undefined ? [] : endogenousTerms[i] ;
             okList.push(aList);
     }
      ui.endogenousTerms.setValue(okList);    

     // we give a label for each endogenous model
     labelize(ui.endogenousTerms, endogenous, "Endogenous");
  
     console.log("....end");
};


var cleanEndogenousTerms= function(ui,context) {

    console.log("cleanEndogenousTerms");
    prepareEndogenousTerms(ui,context);
    var endogenous = getLabels(context.cloneArray(ui.endogenous.value(), []));
    var endogenousTerms = context.cloneArray(ui.endogenousTerms.value(),[]);

    for (var i = 0; i < endogenous.length; i++) {
        endogenousTerms[i]=removeFromList(endogenous[i],endogenousTerms[i],context,1);

    }

    var endogenousSupplierList = context.cloneArray(context.itemsToValues(ui.endogenousSupplier.value()),[]);
    var diff = context.findChanges("endogenousSupplierList",endogenousSupplierList,context);
    
    if (diff.hasChanged) {
      for (var i = 0; i < endogenous.length; i++) 
           for (var j = 0; j < diff.removed.length; j++) {
                endogenousTerms[i]=removeFromList(diff.removed[j],endogenousTerms[i],context,1);
           }
           
    }
    ui.endogenousTerms.setValue(endogenousTerms);
    storeComponent("endogenousTerms",endogenousTerms,context);
    
    

};

var update_syntax=function(ui,context) {
  

    var endogenousTerms = context.cloneArray(ui.endogenousTerms.value(),[]);
    var endogenous=context.cloneArray(ui.endogenous.value(),[]);
    var exogenous=context.cloneArray(ui.exogenous.value(),[]);
    var vars=endogenous.concat(exogenous);
    var varcov=context.cloneArray(ui.varcov.value(),[]);
    var constraints=context.cloneArray(ui.constraints.value(),[]);
    var is_measures= syntax.measures(vars);
    var is_terms =syntax.make(endogenousTerms,getLabels(endogenous));
    syntax.varcov(varcov);
    syntax.constraints(constraints);
    
    if (is_measures || is_terms )
             ui.code.setValue(syntax.lav_syntax);
    else    
             ui.code.setValue("")
    

};

var getLabels=function(alist,context) {
     var okList=[];
     for (var i = 0; i < alist.length; i++) {
         if (alist[i].label!==undefined) {
           if (alist[i].vars===undefined | alist[i].vars===null)
               continue;
           if (alist[i].vars.length===0)
               continue;

           okList.push(alist[i].label);
      }
     }
     return(okList);
};

var unique=function(arr) {
    var u = {}, a = [];
    for(var i = 0, l = arr.length; i < l; ++i){
        var prop=ssort(JSON.stringify(arr[i]));
        if(!u.hasOwnProperty(prop) && arr[i].length>0) {
            a.push(arr[i]);
            u[prop] = 1;
        }
    }
    return a;
};

var ssort= function(str){
  str = str.replace(/[`\[\]"\\\/]/gi, '');
  var arr = str.split(',');
  var sorted = arr.sort();
  return sorted.join('');
};


var labelize = function(widget, labels, prefix) {
     widget.applyToItems(0, (item, index) => {
           item.controls[0].setPropertyValue("label",prefix +" = "+labels[index]);
        });
};


// remove a list or a item from list
// order=0 remove only if term and target term are equal
// order>0 remove if term length>=order 
// for instance, order=1 remove any matching interaction with terms, keeps main effects
// order=2 remove from 3-way interaction on (keep up to 2-way interactions)

var removeFromList = function(quantum, cosmos, context, order = 1) {

    cosmos = normalize(context.cloneArray(cosmos));
    quantum = normalize(context.cloneArray(quantum));

 
     if (cosmos===undefined)
        return([]);
     cosmos = context.cloneArray(cosmos);
       for (var i = 0; i < cosmos.length; i++) {
          if (cosmos[i]===undefined)
             break;
          var aCosmos = context.cloneArray(cosmos[i]);
           for (var k = 0; k < quantum.length; k++) {
             var  test = order === 0 ? FormatDef.term.isEqual(aCosmos,quantum[k]) : FormatDef.term.contains(aCosmos,quantum[k]);
                 if (test && (aCosmos.length >= order)) {
                        cosmos.splice(i, 1);
                        i -= 1;
                    break;    
                    }
          }
            
       }
  
    return(cosmos);
};



var storeComponent = function(id,cosmos,context) {
                    context.workspace[id]=cosmos;
};


var normalize = function(cosmos) {

  if (cosmos===undefined)
          return [];
  if (dim(cosmos)===0)
          cosmos=[cosmos];
          
        for (var i = 0; i < cosmos.length; i++) {
            var aValue = cosmos[i];
            var newValue=dim(aValue)>0 ? aValue : [aValue];
            cosmos[i]=newValue;
        }
        return cosmos;
};

var dim = function(aList) {

    if (!Array.isArray(aList))
           return(0);
    if (!Array.isArray(aList[0]))
           return(1);
    if (!Array.isArray(aList[0][0]))
           return(2);
    if (!Array.isArray(aList[0][0][0]))
           return(3);
    if (!Array.isArray(aList[0][0][0][0]))
           return(4);

  
    return(value);
};



module.exports = events;


},{"./syntax":3}],2:[function(require,module,exports){

// This file is an automatically generated and should not be edited

'use strict';

const options = [{"name":"data","type":"Data","description":{"R":"TO ADD\n"}},{"name":"code","default":"","type":"String","hidden":true,"description":{"R":"TO ADD\n"}},{"name":"donotrun","type":"Bool","title":"Do not run","description":"not present in R. Halt running for more confortable input"},{"name":"endogenous","type":"Array","default":[{"label":"Endogenous1","vars":[]}],"template":{"type":"Group","elements":[{"name":"label","type":"String"},{"name":"vars","type":"Variables","suggested":["continuous"],"permitted":["numeric"]}]},"description":{"R":"A list containing named lists that define the `label` of the latent endogenous variable(s) and the `vars` that belong to that latent.\n"}},{"name":"exogenous","type":"Array","default":[{"label":"Exogenous1","vars":[]}],"template":{"type":"Group","elements":[{"name":"label","type":"String"},{"name":"vars","type":"Variables","suggested":["continuous"],"permitted":["numeric"]}]},"description":{"R":"A list containing named lists that define the `label` of the latent exogenous variables and the `vars` that belong to that latent.\n"}},{"name":"endogenousTerms","title":"Endogenous Latent Variable Models","type":"Array","default":[[]],"template":{"type":"Terms"},"description":{"R":"A list of lists specifying the models for with the mediators as dependent variables.\n"}},{"name":"varcov","title":"Select pairs","type":"Pairs","description":{"R":"A list of lists specifying the  covariances that need to be estimated.\n"}},{"name":"constraints","title":"Insert contraints or defined parameters","type":"Array","default":[],"template":{"type":"String"},"description":{"R":"A list of lists specifying the models random effects.\n"}},{"name":"estimator","title":"Method","type":"List","options":[{"name":"default","title":"Automatic"},{"name":"ML","title":"Maximum Likelihood (ML)"},{"name":"MLM","title":"Robust Maximum Likelihood (MLM)"},{"name":"MLMV","title":"Robust Maximum Likelihood (MLMV)"},{"name":"MLMVS","title":"Robust Maximum Likelihood (MLMVS)"},{"name":"PML","title":"Pairwise maximum likelihood (PML)"},{"name":"GLS","title":"Generalized Least Squares (GSL)"},{"name":"WLS","title":"Weighted Least Squares (WLS)"},{"name":"DWLS","title":"Diagonally weighted Least Squares (DWLS)"},{"name":"WLSM","title":"Robust Weighted Least Squares (WLSM)"},{"name":"WLSMV","title":"Robust Weighted Least Squares (WLSMV)"},{"name":"WLSMVS","title":"Robust Weighted Least Squares (WLSMVS)"},{"name":"ULS","title":"Unweighted Least Squares"}],"default":"default","description":{"R":"The estimator to be used. Can be one of the following: \"ML\" for maximum likelihood, \"GLS\" for (normal theory) generalized least squares, \"WLS\" for weighted least squares (sometimes called ADF estimation), \"ULS\" for unweighted least squares, \"DWLS\" for diagonally weighted least squares, and \"DLS\" for distributionally-weighted least squares. These are the main options that affect the estimation. For convenience, the \"ML\" option can be extended as \"MLM\", \"MLMV\", \"MLMVS\", \"MLF\", and \"MLR\". The estimation will still be plain \"ML\", but now with robust standard errors and a robust (scaled) test statistic. For \"MLM\", \"MLMV\", \"MLMVS\", classic robust standard errors are used (se=\"robust.sem\"); for \"MLF\", standard errors are based on first-order derivatives (information = \"first.order\"); for \"MLR\", `Huber-White' robust standard errors are used (se=\"robust.huber.white\"). In addition, \"MLM\" will compute a Satorra-Bentler scaled (mean adjusted) test statistic (test=\"satorra.bentler\"), \"MLMVS\" will compute a mean and variance adjusted test statistic (Satterthwaite style) (test=\"mean.var.adjusted\"), \"MLMV\" will compute a mean and variance adjusted test statistic (scaled and shifted) (test=\"scaled.shifted\"), and \"MLR\" will compute a test statistic which is asymptotically equivalent to the Yuan-Bentler T2-star test statistic (test=\"yuan.bentler.mplus\"). Analogously, the estimators \"WLSM\" and \"WLSMV\" imply the \"DWLS\" estimator (not the \"WLS\" estimator) with robust standard errors and a mean or mean and variance adjusted test statistic. Estimators \"ULSM\" and \"ULSMV\" imply the \"ULS\" estimator with robust standard errors and a mean or mean and variance adjusted test statistic.\n"}},{"name":"likelihood","title":"ML likelihood approach","type":"List","options":[{"name":"default","title":"Automatic"},{"name":"normal","title":"Normal"},{"name":"wishart","title":"Wishart"}],"default":"default","description":{"R":"Only relevant for ML estimation. If \"wishart\", the wishart likelihood approach is used. In this approach, the covariance matrix has been divided by N-1, and both standard errors and test statistics are based on N-1. If \"normal\", the normal likelihood approach is used. Here, the covariance matrix has been divided by N, and both standard errors and test statistics are based on N. If \"default\", it depends on the mimic option: if mimic=\"lavaan\" or mimic=\"Mplus\", normal likelihood is used; otherwise, wishart likelihood is used.\n"}},{"name":"scoretest","type":"Bool","title":"Univariate","default":true,"description":{"R":"TO ADD\n"}},{"name":"cumscoretest","type":"Bool","title":"Cumulative","default":false,"description":{"R":"TO ADD\n"}},{"name":"se","type":"List","title":"Standard errors","options":[{"name":"auto","title":"Automatic"},{"name":"standard","title":"Standard"},{"name":"robust.sem","title":"Robust"},{"name":"robust.sem","title":"Robust for Clusters"},{"name":"robust.huber.white","title":"Pseudo ML"},{"name":"boot","title":"Bootstrap"}],"default":"auto","description":{"R":"TO ADD\n"}},{"name":"bootci","title":"Bootstrap C.I","type":"List","options":[{"name":"perc","title":"percentiles"},{"name":"bca.simple","title":"adjusted bias-corrected"},{"name":"norm","title":"normal"},{"name":"basic","title":"basic"}],"default":"perc","description":{"R":"Choose the confidence interval type (\"perc\" - percentiles [default], \"bca.simple\" - adjusted bias-corrected, \"norm\" - normal, \"basic\" - basic).\n"}},{"name":"bootN","title":"Bootstrap Rep.","type":"Number","min":50,"default":1000,"description":{"R":"The number of bootstrap samples for estimating confidence intervals.\n"}},{"name":"ci","title":"","type":"Bool","default":true,"description":{"R":"`TRUE` or `FALSE` (default), show confidence intervals\n"}},{"name":"ci_width","title":"Confidence level","type":"Number","min":50,"max":99.9,"default":95,"description":{"R":"A number between 50 and 99.9 (default: 95) specifying the confidence interval width for the parameter estimates.\n"}},{"name":"meanstructure","type":"Bool","title":"Mean structure","default":true,"description":{"R":"If TRUE, the means of the observed variables enter the model. Required for calculating the intercepts of the estimates.\n"}},{"name":"intercepts","type":"Bool","title":"Intercepts of the estimates","default":true,"description":{"R":"`TRUE` or `FALSE` (default), calculate and show the intercepts of the parameter estimates\n"}},{"name":"indirect","type":"Bool","title":"Indirect Effects","default":false,"description":{"R":"`TRUE` or `FALSE` (default), TO ADD\n"}},{"name":"std_lv","title":"Scale / stand. latent vars.","type":"List","options":[{"name":"fix_first","title":"Latent vars.: Fix first indicator (to 1)"},{"name":"std_res","title":"Latent vars.: Fix residual variances (to 1)"}],"default":"fix_first","description":{"R":"If `fix_first` (default), the factor loading of the first indicator is set to 1.0 for every latent variable. If `std_res`, the metric of each latent variable is determined by fixing their (residual) variances to 1.0. If there are multiple groups, \"std_res\" is chosen and \"loadings\" is included in the group.label argument, then only the latent variances i of the first group will be fixed to 1.0, while the latent variances of other groups are set free.\n"}},{"name":"std_ov","type":"Bool","title":"Observed vars.: Standardize before estimation","default":false,"description":{"R":"If TRUE, all observed variables are standardized before entering the analysis.\n"}},{"name":"cov_x","type":"Bool","title":"Fix exogenous covariates","default":false,"description":{"R":"If `TRUE`, the exogenous covariates are considered fixed variables and the means, variances and covariances of these variables are fixed to their sample values. If `FALSE`, they are considered random, and the means, variances and covariances are free parameters. If \"default\", the value is set depending on the mimic option.\n"}},{"name":"cov_y","type":"Bool","title":"Dependent vars (y)","default":true,"description":{"R":"`TRUE` (default) or `FALSE`, TO ADD\n"}},{"name":"cov_lv","type":"Bool","title":"Latent vars","default":true,"description":{"R":"`TRUE` (default) or `FALSE`, is the negation of orthogonal option\n"}},{"name":"cluster","default":"","type":"String","hidden":true,"description":{"R":"Not used in gui\n"}},{"name":"multigroup","title":"Multigroup Analysis Factor","type":"Variable","suggested":["nominal","ordinal"],"permitted":["factor"],"default":null,"description":{"R":"Factor defining groups for multigroup analysis."}},{"name":"eq_loadings","type":"Bool","title":"Loadings","default":false,"description":{"R":"`TRUE` or `FALSE` (default), constrain the factor loadings to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_intercepts","type":"Bool","title":"Intercepts","default":false,"description":{"R":"`TRUE` or `FALSE` (default), constrain the intercepts of the observed variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_residuals","type":"Bool","title":"Residuals","default":false,"description":{"R":"`TRUE` or `FALSE` (default), constrain the residual variances of the observed variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_residual.covariances","type":"Bool","title":"Residual covariances","default":false,"description":{"R":"`TRUE` or `FALSE` (default), constrain the residual covariances of the observed variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_means","type":"Bool","title":"Means","default":false,"description":{"R":"`TRUE` or `FALSE` (default), constrain the intercepts / means of the latent variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_thresholds","type":"Bool","title":"Threshold","default":false,"description":{"R":"`TRUE` or `FALSE` (default), constrain the sample-based thresholds (means for continuous observed mvariables) to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_regressions","type":"Bool","title":"Regressions","default":false,"description":{"R":"`TRUE` or `FALSE` (default), constrain all regression coefficients in the model to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_lv.variances","type":"Bool","title":"Latent variances","default":false,"description":{"R":"`TRUE` or `FALSE` (default), constrain the (residual) variances of the latent variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_lv.covariances","type":"Bool","title":"Latent covariances","default":false,"description":{"R":"`TRUE` or `FALSE` (default), constrain the (residual) covariances of the latent variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"showlabels","type":"Bool","title":"Show parameters labels","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show the labels of the parameters in the model\n"}},{"name":"constraints_examples","type":"Bool","title":"Show syntax examples","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show examples of the lavaan model syntax\n"}},{"name":"outputAdditionalFitMeasures","type":"Bool","title":"Additional fit measures","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show additional fit measures (e.g., CFI, TLI, etc.)\n"}},{"name":"reliability","type":"Bool","title":"Reliability indices","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show additional reliability indices\n"}},{"name":"r2","type":"List","options":[{"name":"none","title":"None"},{"name":"all","title":"All"},{"name":"endo","title":"Endogenous"},{"name":"all","title":"All"}],"default":"none"},{"name":"outputMardiasCoefficients","type":"Bool","title":"Mardia's coefficients","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show Mardia's coefficients for multivariate skewness and kurtosis\n"}},{"name":"outputObservedCovariances","type":"Bool","title":"Observed","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show the covariances and correlations between the observed values of the (manifest) variables\n"}},{"name":"outputImpliedCovariances","type":"Bool","title":"Model-implied (fitted)","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show the covariances and correlations between the model-implied / fitted values of the (manifest) variables\n"}},{"name":"outputResidualCovariances","type":"Bool","title":"Residual","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show the covariances and correlations between the residuals of the (manifest) variables.\n"}},{"name":"outpuCombineCovariances","type":"Bool","title":"Combined into one table","default":false,"description":{"R":"`TRUE` or `FALSE` (default), combine the (up to) three covariance / correlation tables into one table (i.e., showing observed, model-implied and residual values for each variable combination underneath each other)\n"}},{"name":"cov.lv","type":"Bool","title":"Model-implied latent","default":false,"description":{"R":"`TRUE` or `FALSE` (default), model-implied latent covariances\n"}},{"name":"outputModificationIndices","type":"Bool","title":"Modification indices","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show modification indices for if certain terms were removed from the model\n"}},{"name":"miHideLow","type":"Bool","title":"Hide low indices","default":false,"description":{"R":"`TRUE` or `FALSE` (default), hide modification indices below a certain threshold.\n"}},{"name":"miThreshold","type":"Number","title":"Threshold","default":10,"min":0,"description":{"R":"Numeric (default: 10), set a threshold the modification indices must exceed in order to be shown.\n"}},{"name":"diagram","title":"","type":"Bool","default":false,"description":{"R":"`TRUE` or `FALSE` (default), produce a path diagram.\n"}},{"name":"diag_resid","title":"show residuals","type":"Bool","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show the residuals (for the observed variables).\n"}},{"name":"diag_intercepts","title":"show intercepts","type":"Bool","default":true,"description":{"R":"`TRUE` or `FALSE` (default), show the variable intercepts.\n"}},{"name":"diag_paths","title":"Paths Labels","type":"List","options":[{"name":"est","title":"Coefficients"},{"name":"stand","title":"Betas"},{"name":"name","title":"Labels"},{"name":"hide","title":"None"}],"default":"est","description":{"R":"Choose the values shown along the paths (\"est\" [coeffic., default], \"stand\" [betas], \"name\" [labels], \"hide\" [nothing]).\n"}},{"name":"diag_type","title":"Type","type":"List","options":[{"name":"tree","title":"Tree-like"},{"name":"tree2","title":"Tree-like alt."},{"name":"circle","title":"Circular"},{"name":"circle2","title":"Circular alt."},{"name":"spring","title":"Spring"}],"default":"tree","description":{"R":"Choose the layout of the path diagram (\"tree\" [default], \"tree2\", \"circle\", \"circle2\", \"spring\").\n"}},{"name":"diag_rotate","title":"Rotate","type":"List","options":[{"name":"1","title":"Exog. top"},{"name":"2","title":"Exog. left"},{"name":"3","title":"Exog. bottom"},{"name":"4","title":"Exog. right"}],"default":"2","description":{"R":"Choose the rotation of the path diagram (placement of the exog. variables; \"1\": top, \"2\": left (default), \"3\": bottom, \"4\": right).\n"}},{"name":"diag_labsize","title":"Node Size","type":"List","options":[{"name":"small","title":"Small"},{"name":"medium","title":"Medium"},{"name":"large","title":"Large"},{"name":"vlarge","title":"Very Large"}],"default":"medium","description":{"R":"Choose the node size for the variables (default: \"medium\").\n"}},{"name":"diag_shape_man","title":"Manifest shapes","type":"List","options":[{"name":"rectangle","title":"Rectangles"},{"name":"square","title":"Squares"},{"name":"circle","title":"Circles"},{"name":"ellipse","title":"Ellipses"},{"name":"diamond","title":"Diamonds"}],"default":"rectangle","description":{"R":"Choose the shape for the manifest variables (default: \"rectangle\").\n"}},{"name":"diag_shape_lat","title":"Latent shapes","type":"List","options":[{"name":"circle","title":"Circles"},{"name":"rectangle","title":"Rectangles"},{"name":"square","title":"Squares"},{"name":"ellipse","title":"Ellipses"},{"name":"diamond","title":"Diamonds"}],"default":"circle","description":{"R":"Choose the shape for the latent variables (default: \"circle\").\n"}},{"name":"diag_abbrev","title":"Abbreviate","type":"List","options":[{"name":"0","title":"No abbrev."},{"name":"5","title":"5"},{"name":"10","title":"10"},{"name":"15","title":"15"},{"name":"20","title":"20"},{"name":"25","title":"25"}],"default":"5","description":{"R":"Choose the length (characters) of the variable name abbreviations (default: 5).\n"}}];

const view = function() {
    
    

    View.extend({
        jus: "2.0",

        events: [

	],

	update: require('./gui.events').update

    }).call(this);
}

view.layout = ui.extend({

    label: "Structural Equation Modeling",
    jus: "2.0",
    type: "root",
    stage: 0, //0 - release, 1 - development, 2 - proposed
    controls: [
		{
			type: DefaultControls.VariableSupplier,
			typeName: 'VariableSupplier',
			persistentItems: true,
			stretchFactor: 1,
			suggested: ["continuous","ordinal"],
			permitted: ["numeric"],
			controls: [
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					label: "Latent Endogenous Variables",
					controls: [
						{
							type: DefaultControls.ListBox,
							typeName: 'ListBox',
							name: "endogenous",
							height: "large",
							addButton: "Add New Latent",
							events: [
								{ onEvent: 'listItemAdded', execute: require('./gui.events').onChange_items_changed },
								{ onEvent: 'listItemRemoved', execute: require('./gui.events').onChange_items_changed }
							],
							templateName: "linreg-block-template",
							template:
							{
								type: DefaultControls.LayoutBox,
								typeName: 'LayoutBox',
								margin: "normal",
								controls: [
									{
										type: DefaultControls.TextBox,
										typeName: 'TextBox',
										events: [
											{ execute: require('./gui.events').onChange_latentName }
										],
										valueKey: ["label"],
										borderless: true,
										name: "blockName",
										stretchFactor: 1,
										margin: "normal"
									},
									{
										type: DefaultControls.VariablesListBox,
										typeName: 'VariablesListBox',
										valueFilter: "unique",
										events: [
											{ onEvent: 'listItemAdded', execute: require('./gui.events').onChange_items_changed },
											{ onEvent: 'listItemRemoved', execute: require('./gui.events').onChange_items_changed }
										],
										valueKey: ["vars"],
										name: "blockList",
										isTarget: true,
										height: "auto",
										ghostText: "drag variables here"
									}
								]
							}							
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					label: "Latent Exogenous Variables",
					controls: [
						{
							type: DefaultControls.ListBox,
							typeName: 'ListBox',
							name: "exogenous",
							height: "large",
							addButton: "Add New Latent",
							templateName: "linreg-block-template",
							events: [
								{ onEvent: 'listItemAdded', execute: require('./gui.events').onChange_items_changed },
								{ onEvent: 'listItemRemoved', execute: require('./gui.events').onChange_items_changed }
							],
							template:
							{
								type: DefaultControls.LayoutBox,
								typeName: 'LayoutBox',
								margin: "normal",
								controls: [
									{
										type: DefaultControls.TextBox,
										typeName: 'TextBox',
										events: [
											{ execute: require('./gui.events').onChange_latentName }
										],
										valueKey: ["label"],
										borderless: true,
										name: "blockName",
										stretchFactor: 1,
										margin: "normal"
									},
									{
										type: DefaultControls.VariablesListBox,
										typeName: 'VariablesListBox',
										valueFilter: "unique",
										events: [
											{ onEvent: 'listItemAdded', execute: require('./gui.events').onChange_items_changed },
											{ onEvent: 'listItemRemoved', execute: require('./gui.events').onChange_items_changed }
										],
										valueKey: ["vars"],
										name: "blockList",
										isTarget: true,
										height: "auto",
										ghostText: "drag variables here"
									}
								]
							}							
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "multigroup",
							maxItemCount: 1,
							isTarget: true,
							itemDropBehaviour: "overwrite"
						}
					]
				}
			]
		},
		{
			type: DefaultControls.LayoutBox,
			typeName: 'LayoutBox',
			margin: "large",
			style: "inline",
			controls: [
				{
					type: DefaultControls.CheckBox,
					typeName: 'CheckBox',
					name: "donotrun"
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Endogenous models",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.Supplier,
							typeName: 'Supplier',
							name: "endogenousSupplier",
							format: FormatDef.term,
							persistentItems: true,
							stretchFactor: 1,
							events: [
								{ onEvent: 'update', execute: require('./gui.events').onUpdate_endogenousSupplier },
								{ execute: require('./gui.events').onChange_endogenousSupplier }
							],
							controls: [
								{
									type: DefaultControls.TargetLayoutBox,
									typeName: 'TargetLayoutBox',
									transferAction: "interactions",
									controls: [
										{
											type: DefaultControls.ListBox,
											typeName: 'ListBox',
											name: "endogenousTerms",
											height: "large",
											selectable: true,
											templateName: "linreg-block-template",
											template:
											{
												type: DefaultControls.LayoutBox,
												typeName: 'LayoutBox',
												margin: "normal",
												targetArea: true,
												controls: [
													{
														type: DefaultControls.Label,
														typeName: 'Label',
														label: "empty",
														name: "blockName",
														stretchFactor: 1,
														margin: "normal"
													},
													{
														type: DefaultControls.ListBox,
														typeName: 'ListBox',
														enable: "(endogenous)",
														name: "blockList",
														isTarget: true,
														valueFilter: "unique",
														height: "auto",
														ghostText: "drag variables here",
														events: [
															{ execute: require('./gui.events').onChange_endogenousTerms }
														],
														template:
														{
															type: DefaultControls.TermLabel,
															typeName: 'TermLabel'
														}														
													}
												]
											}											
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Variances and covariances",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.VariableSupplier,
							typeName: 'VariableSupplier',
							name: "varcovSupplier",
							populate: "manual",
							persistentItems: true,
							stretchFactor: 1,
							events: [
								{ execute: require('./gui.events').onChange_varcovSupplier },
								{ onEvent: 'update', execute: require('./gui.events').onUpdate_varcovSupplier }
							],
							controls: [
								{
									type: DefaultControls.TargetLayoutBox,
									typeName: 'TargetLayoutBox',
									label: "Select pairs",
									controls: [
										{
											type: DefaultControls.VariablesListBox,
											typeName: 'VariablesListBox',
											name: "varcov",
											fullRowSelect: true,
											isTarget: true,
											events: [
												{ execute: require('./gui.events').onChange_varcov }
											],
											columns: [
												{
													name: "i1",
													stretchFactor: 1,
													template:
													{
														type: DefaultControls.VariableLabel,
														typeName: 'VariableLabel'
													}													
												},
												{
													name: "i2",
													stretchFactor: 1,
													template:
													{
														type: DefaultControls.VariableLabel,
														typeName: 'VariableLabel'
													}													
												}
											]
										}
									]
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Correlated",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "cov_y"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "cov_lv"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Custom model settings",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							stretchFactor: 1,
							controls: [
								{
									type: DefaultControls.TargetLayoutBox,
									typeName: 'TargetLayoutBox',
									controls: [
										{
											type: DefaultControls.ListBox,
											typeName: 'ListBox',
											name: "constraints",
											events: [
												{ execute: require('./gui.events').onChange_constraints }
											],
											height: "large",
											addButton: "Add directive",
											selectable: true,
											templateName: "linreg-block-template",
											template:
											{
												type: DefaultControls.LayoutBox,
												typeName: 'LayoutBox',
												margin: "normal",
												stretchFactor: 1,
												controls: [
													{
														type: DefaultControls.TextBox,
														typeName: 'TextBox',
														name: "randblockList",
														valueFilter: "unique",
														stretchFactor: 0.5,
														borderless: true,
														height: "auto",
														ghostText: "write here"
													}
												]
											}											
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Model options",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Estimation",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "estimator"
								},
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "likelihood",
									enable: "(estimator:ML || estimator:PML)"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Constraints tests",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "scoretest"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "cumscoretest"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Parameters options",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Standard Errors",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "se_auto",
									optionName: "se",
									optionPart: "auto"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "se_standard",
									optionName: "se",
									optionPart: "standard"
								},
								{
									name: "se_robust.sem",
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									optionName: "se",
									optionPart: "robust.sem"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "se_robust.huber.white",
									optionName: "se",
									optionPart: "robust.huber.white"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "se_boot",
									optionName: "se",
									optionPart: "boot"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Bootstrap settings",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bootci_bootperc",
									optionName: "bootci",
									optionPart: "perc",
									enable: "(se:boot)"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bootci_bootnorm",
									optionName: "bootci",
									optionPart: "norm",
									enable: "(se:boot)"
								},
								{
									name: "bootci_bca.simple",
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									optionName: "bootci",
									optionPart: "bca.simple",
									enable: "(se:boot)"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bootci_basic",
									optionName: "bootci",
									optionPart: "basic",
									enable: "(se:boot)"
								},
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "bootN",
									format: FormatDef.number,
									enable: "(se:boot)"
								}
							]
						},
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.Label,
									typeName: 'Label',
									label: "Confidence Intervals",
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											style: "inline",
											controls: [
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "ci",
													margin: "none"
												},
												{
													type: DefaultControls.TextBox,
													typeName: 'TextBox',
													name: "ci_width",
													format: FormatDef.number,
													enable: "(ci)"
												}
											]
										}
									]
								},
								{
									type: DefaultControls.Label,
									typeName: 'Label',
									label: "Constraints",
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "cov_x"
										}
									]
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Estimates",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "meanstructure",
									controls: [
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "intercepts",
											enable: "(meanstructure)"
										}
									]
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "indirect"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Scale / standardize variables",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "std_lv_first",
									optionName: "std_lv",
									optionPart: "fix_first"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "std_lv_res",
									optionName: "std_lv",
									optionPart: "std_res"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "std_ov"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Multi-group analysis",
			collapsed: true,
			stretchFactor: 1,
			style: "list",
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "list",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Equality constraints"
						},
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							style: "inline",
							controls: [
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_loadings"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_intercepts"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_means"
										}
									]
								},
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_thresholds"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_residuals"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_residual.covariances"
										}
									]
								},
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_regressions"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_lv.variances"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_lv.covariances"
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Output options",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									style: "inline",
									controls: [
										{
											type: DefaultControls.Label,
											typeName: 'Label',
											label: "Information"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "showlabels"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "constraints_examples"
										}
									]
								},
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									style: "inline",
									controls: [
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											margin: "large",
											style: "list",
											controls: [
												{
													type: DefaultControls.LayoutBox,
													typeName: 'LayoutBox',
													margin: "large",
													style: "list",
													controls: [
														{
															type: DefaultControls.Label,
															typeName: 'Label',
															label: "Additional outputs"
														},
														{
															type: DefaultControls.CheckBox,
															typeName: 'CheckBox',
															name: "outputAdditionalFitMeasures"
														},
														{
															type: DefaultControls.CheckBox,
															typeName: 'CheckBox',
															name: "outputMardiasCoefficients"
														},
														{
															type: DefaultControls.CheckBox,
															typeName: 'CheckBox',
															name: "reliability"
														}
													]
												},
												{
													type: DefaultControls.LayoutBox,
													typeName: 'LayoutBox',
													margin: "large",
													style: "list",
													controls: [
														{
															type: DefaultControls.Label,
															typeName: 'Label',
															label: "R-squared"
														},
														{
															type: DefaultControls.RadioButton,
															typeName: 'RadioButton',
															name: "r2_none",
															optionName: "r2",
															optionPart: "none"
														},
														{
															type: DefaultControls.RadioButton,
															typeName: 'RadioButton',
															name: "r2_endo",
															optionName: "r2",
															optionPart: "endo"
														},
														{
															type: DefaultControls.RadioButton,
															typeName: 'RadioButton',
															name: "r2_all",
															optionName: "r2",
															optionPart: "all"
														}
													]
												}
											]
										},
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											margin: "large",
											style: "list",
											controls: [
												{
													type: DefaultControls.Label,
													typeName: 'Label',
													label: "Covariances and correlations"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "outputObservedCovariances"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "outputImpliedCovariances"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "outputResidualCovariances"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "outpuCombineCovariances"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "cov.lv"
												}
											]
										},
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											margin: "large",
											style: "list",
											controls: [
												{
													type: DefaultControls.Label,
													typeName: 'Label',
													label: "Modification indices"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "outputModificationIndices",
													controls: [
														{
															type: DefaultControls.CheckBox,
															typeName: 'CheckBox',
															name: "miHideLow",
															enable: "(outputModificationIndices)",
															controls: [
																{
																	type: DefaultControls.TextBox,
																	typeName: 'TextBox',
																	name: "miThreshold",
																	format: FormatDef.number,
																	enable: "(miHideLow)"
																}
															]
														}
													]
												}
											]
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Path diagram",
			collapsed: true,
			stretchFactor: 1,
			style: "list",
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					style: "list",
					controls: [
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							stretchFactor: 1,
							style: "inline",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "diagram",
									style: "inline",
									controls: [
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											margin: "none",
											stretchFactor: 1,
											style: "list",
											controls: [
												{
													type: DefaultControls.Label,
													typeName: 'Label',
													label: "Path diagram",
													style: "list",
													controls: [
														{
															type: DefaultControls.LayoutBox,
															typeName: 'LayoutBox',
															margin: "none",
															stretchFactor: 1,
															style: "inline",
															controls: [
																{
																	type: DefaultControls.CheckBox,
																	typeName: 'CheckBox',
																	name: "diag_resid",
																	enable: "(diagram)"
																},
																{
																	type: DefaultControls.CheckBox,
																	typeName: 'CheckBox',
																	name: "diag_intercepts",
																	enable: "(diagram && meanstructure)"
																}
															]
														}
													]
												}
											]
										}
									]
								}
							]
						},
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							stretchFactor: 1,
							style: "inline",
							controls: [
								{
									type: DefaultControls.Label,
									typeName: 'Label',
									label: "Paths",
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "diag_paths_est",
											optionName: "diag_paths",
											optionPart: "est",
											enable: "(diagram)"
										},
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "diag_paths_stand",
											optionName: "diag_paths",
											optionPart: "stand",
											enable: "(diagram)"
										},
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "diag_paths_name",
											optionName: "diag_paths",
											optionPart: "name",
											enable: "(diagram)"
										},
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "diag_paths_hide",
											optionName: "diag_paths",
											optionPart: "hide",
											enable: "(diagram)"
										}
									]
								},
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									stretchFactor: 1,
									style: "list",
									controls: [
										{
											type: DefaultControls.Label,
											typeName: 'Label',
											label: "Layout",
											margin: "large",
											style: "list",
											controls: [
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_type",
													enable: "(diagram)"
												},
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_rotate",
													enable: "(diagram)"
												}
											]
										}
									]
								},
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									stretchFactor: 1,
									style: "list",
									controls: [
										{
											type: DefaultControls.Label,
											typeName: 'Label',
											label: "Nodes",
											margin: "large",
											style: "list",
											controls: [
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_labsize",
													enable: "(diagram)"
												},
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_shape_man",
													enable: "(diagram)"
												},
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_shape_lat",
													enable: "(diagram)"
												},
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_abbrev",
													enable: "(diagram)"
												}
											]
										}
									]
								}
							]
						}
					]
				}
			]
		}
	]
});

module.exports = { view : view, options: options };

},{"./gui.events":1}],3:[function(require,module,exports){
const syntax = {
    measures: function(vars) {
      var found = false;
      var astring="";
      var terms="";
      for(let i = 0; i < vars.length; i++) {
          if (vars[i].vars===undefined | vars[i].vars===null)
               continue;
          if (vars[i].vars.length===0)
               continue;
          found=true;     
          terms=vars[i].vars.join("+");
          astring+=vars[i].label+'=~'+terms+'\n ';
    }
    this.lav_syntax=astring;
    return(found);

    },
    make: function(eterms,latnames) {
      
      var found=false;
      var astring="";
      var terms="";
        for(let i = 0; i < latnames.length; i++) {
          if (eterms[i]===undefined | eterms[i]===null)
              continue;
          if (eterms[i].length===0)
              continue;
          found=true;
          terms=eterms[i].join("+");
          astring+=latnames[i]+'~'+terms+'\n';
    }
    this.lav_syntax+=astring;
    return(found);
    },
    varcov: function(pairs) {
      var astring="";
      var terms="";
        for(let i = 0; i < pairs.length; i++) {
          if (pairs[i].i1===null | pairs[i].i2===null)
               continue;
          astring+=pairs[i].i1+'~~'+pairs[i].i2+'\n ';
    }
    this.lav_syntax+=astring;
    },
    constraints: function(alist) {
      
      var astring="";
      for(let i = 0; i < alist.length; i++) {
          if (alist[i]!==null)
              astring+=' '+alist[i]+'  \n ';
      }
      this.lav_syntax+=astring;
    },
    clean: function() {
      this.lav_syntax="";
      
    }

};

module.exports = syntax;

},{}]},{},[2])(2)
});